//TR$I01AC JOB 'TRAIN-RIGHT',MSGCLASS=H,CLASS=S,                        00010000
// NOTIFY=&SYSUID                                                       00020000
//*                                                                     00030000
//**********************************************************************00040000
//*                                                                    *00050000
//*       T  R  A  N  S  L  A  T  E    &    C  O  M  P  I  L  E        *00060000
//*        C  I  C  S    S A M P L E    P  R  O  G  R  A  M S          *00070000
//*                                                                    *00080000
//*  SET THE SYMBOLIC VARIABLES TO THE FOLLOWING VALUES:               *00090000
//*                                                                    *00100000
//*  SRCLIB   - THE DATASET NAME OF THE PDS WHERE PROGRAM RESIDES.     *00110000
//*  COPYLIB  - DATASET NAME OF THE PDS WHERE SYMBOLIC MAPS RESIDE     *00120000
//*             FROM THE MAPJCL.                                       *00130000
//*  LOADLIB  - DATASET NAME OF THE PDS WHERE CICS LOADS PROGRAMS      *00140000
//*             AND MAPSETS FROM.                                      *00150000
//*  CICSCOPY - DATASET NAME OF THE PDS WHERE DFHBMSCA, DFHAID,        *00160000
//*             LINK EDIT INCLUDE STATEMENT AND OTHER CICS             *00170000
//*             COPYBOOKS.                                             *00180000
//*  CICSLOAD - DATASET NAME WHERE THE TRANSLATOR, STUB PROGRAM,       *00190000
//*             AND OTHER CICS MODULES RESIDE.                         *00200000
//*  LECOPY   - THE DATASET NAME WHERE THE LANGUAGE ENVIRONMENT        *00210000
//*             COPYBOOKS AND SAMPLE PROGRAMS RESIDE.                  *00220000
//*  LELINK   - THE DATASET NAME WHERE THE LANGUAGE ENVIRONMENT        *00230000
//*             LINK ROUTINES RESIDE.                                  *00240000
//*                                                                     00250000
//*  CHANGE '#' TO THE CICS SAMPLE LIBRARY (FOR DFHDHTXO).              00260000
//*                                                                     00270000
//**********************************************************************00280000
//*                                                                     00290000
//SETVARS  SET TEAMID=,                                                 00300000
//             SRCLIB=TR$I01.CICSA.LIB,                                 00310000
//             MEMBER=,                                                 00320000
//             COPYLIB=TR$I01.CICSKWC.MAPDSECT,                         00330000
//             LOADLIB=TR$I01.CICSKWC.LOADLIB,                          00340000
//             CICSCOPY=DFH410.CICS.SDFHCOB,                            00350001
//             CICSLOAD=DFH410.CICS.SDFHLOAD,                           00360001
//             LECOPY=CEE.SCEESAMP,                                     00370000
//             LELINK=CEE.SCEELKED                                      00380000
//*                                                                     00390000
//PRIVPROC JCLLIB ORDER=(&SRCLIB)                                       00400000
//*                                                                     00410000
//TRPGM00W EXEC COB3PROC,TEAMID=00,MEMBER=TRPGM00W                      00420002
//TRPGM71  EXEC COB3PROC,TEAMID=71,MEMBER=TRPGM71                       00430000
//TRPGM71W EXEC COB3PROC,TEAMID=71,MEMBER=TRPGM71W                      00440000
//TRPGM72  EXEC COB3PROC,TEAMID=72,MEMBER=TRPGM72,                      00450000
//         COND.LINK=((0,NE,TRANS),(4,LT,COBOL))                        00460000
//TRPGM73  EXEC COB3PROC,TEAMID=73,MEMBER=TRPGM73,                      00470000
//         COND.LINK=((0,NE,TRANS),(4,LT,COBOL))                        00480000
//TRPGM74  EXEC COB3PROC,TEAMID=74,MEMBER=TRPGM74                       00490000
//TRPGM75N EXEC COB3PROC,TEAMID=75,MEMBER=TRPGM75N                      00500000
//TRPGM75L EXEC COB3PROC,TEAMID=75,MEMBER=TRPGM75L                      00510000
//TRPGM75X EXEC COB3PROC,TEAMID=75,MEMBER=TRPGM75X                      00520000
//TRPGM75B EXEC COB3PROC,TEAMID=75,MEMBER=TRPGM75B                      00530000
//TRPGM75D EXEC COB3PROC,TEAMID=75,MEMBER=TRPGM75D                      00540000
//TRPGM76L EXEC COB3PROC,TEAMID=76,MEMBER=TRPGM76L                      00550000
//TRPGM76X EXEC COB3PROC,TEAMID=76,MEMBER=TRPGM76X                      00560000
//TRPGM76B EXEC COB3PROC,TEAMID=76,MEMBER=TRPGM76B                      00570000
//TRPGM76D EXEC COB3PROC,TEAMID=76,MEMBER=TRPGM76D                      00580000
//TRPGM81  EXEC COB3PROC,TEAMID=81,MEMBER=TRPGM81                       00590000
//TRPGM82  EXEC COB3PROC,TEAMID=82,MEMBER=TRPGM82                       00600000
//TRPGM83  EXEC COB3PROC,TEAMID=83,MEMBER=TRPGM83                       00610000
//TRPGM83D EXEC COB3PROC,TEAMID=83,MEMBER=TRPGM83D                      00620000
//TRPGM84  EXEC COB3PROC,TEAMID=84,MEMBER=TRPGM84                       00630000
//TRPGM85  EXEC COB3PROC,TEAMID=85,MEMBER=TRPGM85                       00640000
//TRPGM86  EXEC COB3PROC,TEAMID=86,MEMBER=TRPGM86                       00650000
//TRPGM87  EXEC COB3PROC,TEAMID=87,MEMBER=TRPGM87                       00660000
//TRPGM88  EXEC COB3PROC,TEAMID=88,MEMBER=TRPGM88                       00670000
//TRPGM93  EXEC COB3PROC,TEAMID=93,MEMBER=TRPGM93                       00680000
//TRPGM94  EXEC COB3PROC,TEAMID=94,MEMBER=TRPGM94                       00690000
//TRPGM95  EXEC COB3PROC,TEAMID=95,MEMBER=TRPGM95                       00700000
//         SET COPYLIB=DFH410.CICS.SDFHSAMP                             00710001
//TRPDOC00 EXEC COB3PROC,TEAMID=00,MEMBER=TRPDOC00                      00720000
//LINK.SYSLMOD DD DSN=&LOADLIB(TRPDOC00),DISP=SHR                       00730000
//                                                                      00740000
